package com.xydl.cac.service.impl;

import com.xydl.cac.entity.Bdz;
import com.xydl.cac.repository.BdzRepository;
import com.xydl.cac.service.BdzService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class BdzServiceImpl implements BdzService {

    @Resource
    BdzRepository repository;

    @Override
    public List<Bdz> listAll() {
        return repository.findAll();
    }

    @Override
    public Bdz add(Bdz item) {
        item.setId(null);
        return repository.save(item);
    }

    @Override
    public void update(Bdz item) {
        repository.save(item);
    }

    @Override
    public void delete(Integer id) {
        repository.deleteById(id);
    }
}
