package com.xydl.cac.service.impl;

import com.xydl.cac.entity.Bdz;
import com.xydl.cac.entity.Jg;
import com.xydl.cac.repository.BdzRepository;
import com.xydl.cac.repository.JgRepository;
import com.xydl.cac.service.JgService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Optional;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class JgServiceImpl implements JgService {

    @Resource
    JgRepository repository;
    @Resource
    BdzRepository bdzRepository;

    @Override
    public List<Jg> listAll(Integer bdzid) {
        if (bdzid == null) {
            return repository.findAll();
        } else {
            return repository.findByBdzid(bdzid);
        }
    }

    @Override
    public Jg add(Jg item) throws Exception {
        item.setId(null);
        Optional<Bdz> optional = bdzRepository.findById(item.getBdzid());
        if (!optional.isPresent()) {
            throw new Exception("未找到该变电站");
        }
        return repository.save(item);
    }

    @Override
    public void update(Jg item) {
        repository.save(item);
    }

    @Override
    public void delete(Integer id) {
        repository.deleteById(id);
    }

    @Override
    public Jg detail(Integer id) throws Exception {
        Optional<Jg> optional = repository.findById(id);
        if (!optional.isPresent()) {
            throw new Exception("未找到该区域");
        }
        return null;
    }
}
