package com.xydl.cac.service.impl;

import com.xydl.cac.entity.Jg;
import com.xydl.cac.entity.Lx;
import com.xydl.cac.entity.Zsb;
import com.xydl.cac.repository.LxRepository;
import com.xydl.cac.repository.ZsbRepository;
import com.xydl.cac.service.JgService;
import com.xydl.cac.service.ZsbService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Optional;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class ZsbServiceImpl implements ZsbService {

    @Resource
    ZsbRepository repository;
    @Resource
    JgService jgService;
    @Resource
    LxRepository lxRepository;

    @Override
    public List<Zsb> listAll(Integer jgid) {
        if (jgid == null) {
            return repository.findAll();
        } else {
            return repository.findByJgid(jgid);
        }
    }

    @Override
    public Zsb add(Zsb item) throws Exception {
        item.setId(null);
        Jg jg = jgService.detail(item.getJgid());
        item.setBdzid(jg.getBdzid());
        Optional<Lx> optional = lxRepository.findById(item.getLxid());
        if (!optional.isPresent()) {
            throw new Exception("未找到该设备类型");
        }
        return repository.save(item);
    }

    @Override
    public void update(Zsb item) throws Exception {
        Jg jg = jgService.detail(item.getJgid());
        item.setBdzid(jg.getBdzid());
        Optional<Lx> optional = lxRepository.findById(item.getLxid());
        if (!optional.isPresent()) {
            throw new Exception("未找到该设备类型");
        }
        repository.save(item);
    }

    @Override
    public void delete(Integer id) {
        repository.deleteById(id);
    }
}
